<?php
/**********************************************\
| SMFSHOP (Shop MOD for Simple Machines Forum) |
|         (c) 2006 DanSoft Australia           |
|      http://www.dansoftaustralia.net/        |
\**********************************************/

//File: Shop-Inventory.php
//      Inventory stuff (view inventory, use item, view other's inventory)
//		This is not called directly. The code in here is used in Shop.php

// VERSION: 2.2 (Build 10)
// $Date: 2006-07-29 19:39:33 +1000 (Sat, 29 Jul 2006) $
// $Id: Shop-Inventory.php 10 2006-07-29 09:39:33Z daniel15 $

if ($_GET['do'] == "inv") {
	$context['linktree'][] = array(
		'url' => "$scripturl?action=shop;do=inv",
		'name' => $txt['shop_yourinv'],
	);

	$context['shop_items_list'] = "
		<tr valign='top' class='windowbg'>
			<td style='padding-bottom: 2ex;' width='32'>
				<b>{$txt['shop_image']}</b>
			</td>
			<td>
				<b>{$txt['shop_name']}</b>
			</td>
			<td>
				<b>{$txt['shop_description']}</b>
			</td>
			<td width='18%'>
				<b>Paid/Use</b>
			</td>
		</tr>";

	$alternating = "windowbg2";
	$itemRows = array();

	$result = db_query("SELECT it.name, it.desc, it.input_needed, it.can_use_item, it.image,
							   inv.amtpaid, inv.id, inv.trading, inv.tradecost
						FROM {$db_prefix}shop_inventory AS inv, {$db_prefix}shop_items AS it
						WHERE inv.ownerid = {$ID_MEMBER} AND inv.itemid = it.id
						ORDER BY it.name ASC",
						__FILE__, __LINE__);

	while ($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
		$itemRows[] = $row;
	}

	if (!isset($_GET['page'])) $_GET['page'] = 1;
	if (!isset($modSettings['shopItemsPerPage'])) $modSettings['shopItemsPerPage'] = 15;
	
	$pageCount = ceil(count($itemRows) / $modSettings['shopItemsPerPage']);
	$firstItem = ($_GET['page'] * $modSettings['shopItemsPerPage']) - $modSettings['shopItemsPerPage'];
	
	for ($x = $firstItem; ($x < $firstItem + $modSettings['shopItemsPerPage']) && ($x < count($itemRows)) ; $x++) {
	
		$context['shop_items_list'] .= "
			<tr valign='top' class='{$alternating}'>
				<td>
					<img border='0' width='{$modSettings['shopImageWidth']}' height='{$modSettings['shopImageHeight']}' src='{$boardurl}/Sources/shop/item_images/{$itemRows[$x]['image']}'>
				</td>
				<td style='padding-bottom: 2ex;' width='20%'>
					{$itemRows[$x]['name']}
				</td>
				<td>
					{$itemRows[$x]['desc']}
				</td>
				<td width='18%'>
					Paid: {$itemRows[$x]['amtpaid']}<br />";

		//order of if's is IMPORTANT here!
		if ($itemRows[$x]['trading'] == 1) {
			$context['shop_items_list'] .= "<i>".sprintf($txt['shop_trading'], formatMoney($itemRows[$x]['tradecost']))."</i><br /><a href='$scripturl?action=shop;do=trade_stop;id={$itemRows[$x]['id']}'>{$txt['shop_stoptrade']}</a>";
		} else {
			if ($itemRows[$x]['can_use_item'] == false) {
				$context['shop_items_list'] .= "<b>{$txt['shop_unusable']}</b>";
			} elseif ($itemRows[$x]['input_needed'] == false) {
				$context['shop_items_list'] .= "<a href='{$scripturl}?action=shop;do=inv3;id={$itemRows[$x]['id']}'>{$txt['shop_use']}</a>";
			} else {
				$context['shop_items_list'] .= "<a href='{$scripturl}?action=shop;do=inv2;id={$itemRows[$x]['id']}'>{$txt['shop_use']}</a>";
			}
			
			if ($modSettings['shopTradeEnabled'])
				$context['shop_items_list'] .= "<br /><a href='{$scripturl}?action=shop;do=trade_sell;id={$itemRows[$x]['id']}'>{$txt['shop_tradeitem']}</a>";
		}
	
		$context['shop_items_list'] .= "</td></tr>";

		if ($alternating == "windowbg") {
			$alternating = "windowbg2";
		} else {
			$alternating = "windowbg";
		}
	}
	
	$context['shop_pages'] = $pageCount;
	$context['shop_current_page'] = $_GET['page'];
	$context['shop_page_link'] = $scripturl."?action=shop;do=inv";
	$context['sub_template'] = "inventory";
	loadTemplate('Shop');
		
} elseif ($_GET['do'] == "inv2") {
	$context['linktree'][] = array(
		'url' => "$scripturl?action=shop;do=inv",
		'name' => $txt['shop_yourinv'],
	);
	
	$result = db_query("SELECT it.module, it.can_use_item, it.info1, it.info2, it.info3,
							   it.info4, inv.ownerid
						FROM {$db_prefix}shop_inventory AS inv, {$db_prefix}shop_items AS it
						WHERE inv.id = {$_GET['id']} AND inv.itemid = it.id
						LIMIT 1", __FILE__, __LINE__);

	$row = mysql_fetch_array($result, MYSQL_ASSOC);
	if ($row['ownerid'] !== $ID_MEMBER) { //trying to steal other person's item
		die($txt['shop_use_others_item']);
	} elseif ($row['can_use_item'] == false) {
		die($txt['shop_unusable']);
	}

	$context['shop_buy_message'] = "{$txt['shop_input']}<br />
		 <form action='$scripturl?action=shop;do=inv3;id={$_GET['id']}' method='POST'>";


	//additional info, just in case it's needed in getUseInput() function
	$item_info[1] = $row['info1'];
	$item_info[2] = $row['info2'];
	$item_info[3] = $row['info3'];
	$item_info[4] = $row['info4'];

	require("$sourcedir/shop/item_engine.php");
	require("$sourcedir/shop/items/{$row['module']}.php");
	eval("\$temp = new item_{$row['module']};");
	$context['shop_buy_message'] .= $temp->getUseInput();
	$context['shop_buy_message'] .= "<br /><input type='submit' value='{$txt['shop_use']}'></form>";
	
	$context['sub_template'] = "message";
	loadTemplate('Shop');
		
} elseif ($_GET['do'] == "inv3") {
	$context['linktree'][] = array(
		'url' => "$scripturl?action=shop;do=inv",
		'name' => $txt['shop_yourinv'],
	);

	$result = db_query("SELECT it.module, it.can_use_item, it.info1, it.info2, it.info3,
							   it.info4, inv.ownerid
						FROM {$db_prefix}shop_inventory AS inv, {$db_prefix}shop_items AS it
						WHERE inv.id = {$_GET['id']} AND inv.itemid = it.id
						LIMIT 1", __FILE__, __LINE__);

	$row = mysql_fetch_array($result, MYSQL_ASSOC);
	if ($row['ownerid'] !== $ID_MEMBER) { //trying to steal other person's item
		die($txt['shop_use_others_item2']);
	} elseif ($row['can_use_item'] == false) {
		die($txt['shop_unusable']);
	}

	//additional info
	$item_info[1] = $row['info1'];
	$item_info[2] = $row['info2'];
	$item_info[3] = $row['info3'];
	$item_info[4] = $row['info4'];

	require("$sourcedir/shop/item_engine.php");
	require("$sourcedir/shop/items/{$row['module']}.php");

	eval("\$temp = new item_{$row['module']};");
	$context['shop_buy_message'] = $temp->onUse();
	$context['shop_buy_message'] .= "<br /><br /><a href='$scripturl?action=shop;do=inv'>{$txt['shop_back2inv']}</a>";

	$result = db_query("DELETE FROM {$db_prefix}shop_inventory
						WHERE id = {$_GET['id']}", 
						__FILE__, __LINE__);
						
	$context['sub_template'] = "message";
	loadTemplate('Shop');
	
} elseif ($_GET['do'] == "invother") { //view other member's inventory
	
	$context['linktree'][] = array(
		'url' => "$scripturl?action=shop;do=invother",
		'name' => $txt['shop_invother'],
	);
	
	$context['sub_template'] = "otherInventory";
	loadTemplate('Shop');
	
} elseif ($_GET['do'] == "invother2") {

	 $context['linktree'][] = array(
		'url' => "$scripturl?action=shop;do=invother",
		'name' => $txt['shop_invother'],
	);

	$result = db_query("SELECT ID_MEMBER, memberName, realName
						  FROM {$db_prefix}members
						  WHERE memberName = '{$_REQUEST['member']}'
						  LIMIT 1", __FILE__, __LINE__);
	$row = mysql_fetch_array($result, MYSQL_ASSOC);

	if (($row['ID_MEMBER'] <> $_REQUEST['member']) && $row['memberName'] <> $_REQUEST['member']) {
		die(sprintf($txt['shop_member_no_exist'], $_REQUEST['member']));
	}
	
	$usersid = $row['ID_MEMBER'];
	$usersname = $row['realName'];

	$context['linktree'][] = array(
		'url' => "$scripturl?action=shop;do=invother2;member={$_REQUEST['member']}",
		'name' => sprintf($txt['shop_viewing_inv'], $usersid, $usersname),
	);


	$context['shop_items_list'] = "
		<tr>
		   <td colspan='3'>
			   <b><center>Below is a list of all the items member ID {$usersid} ({$usersname}) has:</center></b>
		   </td>
		</tr>
		<tr valign='top' class='windowbg'>
			<td style='padding-bottom: 2ex;' width='32'>
				<b>{$txt['shop_image']}</b>
			</td>
			<td>
				<b>{$txt['shop_name']}</b>
			</td>
			<td>
				<b>{$txt['shop_description']}</b>
			</td>
		</tr>";
	$alternating = "windowbg2";

	$result = db_query("SELECT it.name, it.desc, it.image, inv.id
						FROM {$db_prefix}shop_inventory AS inv, {$db_prefix}shop_items AS it
						WHERE ownerid = {$usersid} AND inv.itemid = it.id",
						__FILE__, __LINE__);

	while ($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
		$context['shop_items_list'] .= "
			<tr valign='top' class='{$alternating}'>
				<td>
					<img border='0' width='32' height='32' src='{$boardurl}/Sources/shop/item_images/{$row['image']}'>
				</td>
				<td style='padding-bottom: 2ex;' width='20%'>
					{$row['name']}
				</td>
				<td>
					{$row['desc']}
				</td>";

		$context['shop_items_list'] .= "</td></tr>";

		if ($alternating == "windowbg") {
			$alternating = "windowbg2";
		} else {
			$alternating = "windowbg";
		}
	}
		
	$context['sub_template'] = "inventory";
	loadTemplate('Shop');
}
?>