<?php
/**********************************************\
| SMFSHOP (Shop MOD for Simple Machines Forum) |
|         (c) 2006 DanSoft Australia           |
|      http://www.dansoftaustralia.net/        |
\**********************************************/

//File: Shop-Trade.php
//      Trade Centre stuff (trade listing, etc.)
//		This is not called directly. The code in here is used in Shop.php

// VERSION: 2.2 (Build 10)
// $Date: 2006-07-29 19:39:33 +1000 (Sat, 29 Jul 2006) $
// $Id: Shop-Trade.php 10 2006-07-29 09:39:33Z daniel15 $

if ($_GET['do'] == "trade") {
	$context['linktree'][] = array(
		'url' => "$scripturl?action=shop;do=trade",
		'name' => $txt['shop_trade'],
	);
	
	$result = db_query("SELECT money
				FROM {$db_prefix}members
				WHERE ID_MEMBER = $ID_MEMBER
				LIMIT 1", __FILE__, __LINE__);
	
	$row = mysql_fetch_array($result, MYSQL_ASSOC);
	$usersmoney = $row['money'];
	
	$context['shop_trade_list'] = "";
	$alternating = "windowbg2";
	
	$result = db_query("SELECT it.name, it.desc, it.image, inv.id, m.realName, inv.tradecost
						FROM {$db_prefix}shop_inventory AS inv, {$db_prefix}shop_items AS it,
							 {$db_prefix}members AS m
						WHERE inv.trading = 1 AND inv.itemid = it.id AND 
							  m.ID_MEMBER = inv.ownerid",
						__FILE__, __LINE__);

	while ($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
		
		$context['shop_trade_list'] .= "
			<tr valign='top' class='{$alternating}'>
				<td>
					<img border='0' width='32' height='32' src='{$boardurl}/Sources/shop/item_images/{$row['image']}'>
				</td>
				<td style='padding-bottom: 2ex;' width='20%'>
					{$row['name']}
				</td>
				<td>
					{$row['desc']}<br />
					<i>".sprintf($txt['shop_trade_saleby'], $row['realName'])."</i>
				</td>
				<td width='18%'>
					{$txt['shop_price']}: {$row['tradecost']}<br />";
	
		if ($usersmoney >= $row['tradecost']) {
			$context['shop_trade_list'] .= "<a href='$scripturl?action=shop;do=trade_buy;id={$row['id']}'>{$txt['shop_buynow']}</a>";
		} else {
			$context['shop_trade_list'] .= "<b>".sprintf($txt['shop_need'], formatMoney($row['tradecost'] - $usersmoney))."</b>";
		}

		$context['shop_trade_list'] .= "</td></tr>";

		$alternating = ($alternating == "windowbg") ? "windowbg2" : "windowbg";
	}
	
	$context['sub_template'] = "userTrade";
	loadTemplate('Shop');
	
} elseif ($_GET['do'] == "trade_buy") {
	$context['linktree'][] = array(
		'url' => "$scripturl?action=shop;do=trade",
		'name' => $txt['shop_trade'],
	);

	//Current user's details
	$result = db_query("SELECT money, realName, memberName
						FROM {$db_prefix}members
						WHERE ID_MEMBER = {$ID_MEMBER}
						LIMIT 1", __FILE__, __LINE__);
	
	$row_user = mysql_fetch_array($result, MYSQL_ASSOC);

	//item information
	$_GET['id'] = (int) $_GET['id'];
					
	//Get information on the item in  question	
	$result = db_query("SELECT it.name, inv.tradecost, inv.trading, inv.ownerid, m.realName,
							   m.emailAddress
						FROM {$db_prefix}shop_inventory AS inv, {$db_prefix}shop_items AS it,
							 {$db_prefix}members AS m
						WHERE inv.id = {$_GET['id']} AND inv.itemid = it.id
						LIMIT 1", __FILE__, __LINE__);
						
	$row_item = mysql_fetch_array($result, MYSQL_ASSOC);
	
	if ($row_item['trading'] != 1) {
		$context['shop_buy_message'] = $txt['shop_no_sale'];
	} elseif ($row_user['money'] < $row_item['tradecost']) {
		$context['shop_buy_message'] = sprintf($txt['shop_not_enough_money'], $cost - $usersmoney);
	} else {
		//change item info (owner, amount paid, trading = not anymore)
		$result = db_query("UPDATE {$db_prefix}shop_inventory
							SET ownerid = {$ID_MEMBER}, amtpaid = {$row_item['tradecost']},
								trading = 0
							WHERE id = {$_GET['id']}
							LIMIT 1", __FILE__, __LINE__);
							
		//decrease user's money
		$result = db_query("UPDATE {$db_prefix}members
							SET money = money - {$row_item['tradecost']}
							WHERE ID_MEMBER = {$ID_MEMBER}
							LIMIT 1", __FILE__, __LINE__);
							
		//give money to old owner
		$result = db_query("UPDATE {$db_prefix}members
							SET money = money + {$row_item['tradecost']}
							WHERE ID_MEMBER = {$row_item['ownerid']}
							LIMIT 1", __FILE__, __LINE__);			
		 
		$pmfrom = array(
			'id' => $ID_MEMBER,
			'name' => $row_user['realName'],
			'username' => $row_user['memberName']
		);
		
		$pmto = array(
			'to' => array($row_item['ownerid']),
			'bcc' => array()
		);
		
		$subject = sprintf($txt['shop_im_trade_subject'], $row_item['name']);
		$message = sprintf($txt['shop_im_trade_message'], $ID_MEMBER, $row_user['realName'], $row_item['name'], formatMoney($row_item['tradecost']));
		sendpm($pmto, $subject, $message, 0, $pmfrom);
			
		$context['shop_buy_message'] = sprintf($txt['shop_trade_bought_item'], $row_item['name'], $row_item['realName']);
	}
	
	$context['sub_template'] = "message";
	loadTemplate('Shop');
} elseif ($_GET['do'] == "trade_sell") {
	$context['linktree'][] = array(
		'url' => "$scripturl?action=shop;do=inv",
		'name' => $txt['shop_yourinv'],
	);
	
	$_GET['id'] = (int) $_GET['id'];	
	$result = db_query("SELECT amtpaid
						FROM {$db_prefix}shop_inventory
						WHERE id = {$_GET['id']}", __FILE__, __LINE__);
	$row = mysql_fetch_array($result, MYSQL_ASSOC);
	$context['shop_paid'] = $row['amtpaid'];
	
	$context['sub_template'] = "tradeItem";
	loadTemplate('Shop');
	
} elseif ($_GET['do'] == "trade_sell2") {
	$context['linktree'][] = array(
		'url' => "$scripturl?action=shop;do=inv",
		'name' => $txt['shop_yourinv'],
	);
	
	$_POST['id'] = (int) $_POST['id'];
	$_POST['sellfor'] = (int) $_POST['sellfor'];
	$result = db_query("SELECT ownerid
						FROM {$db_prefix}shop_inventory
						WHERE id = {$_POST['id']}
						LIMIT 1", __FILE__, __LINE__);

	$row = mysql_fetch_array($result, MYSQL_ASSOC);
	if ($_POST['sellfor'] <= 0) {
		$context['shop_buy_message'] = $txt['shop_trade_negative'];
	} elseif ($row['ownerid'] !== $ID_MEMBER) { //trying to steal other person's item
		$context['shop_buy_message'] = $txt['shop_use_others_item'];
	} else {
		$result = db_query("UPDATE {$db_prefix}shop_inventory
							SET trading = 1, 
								tradecost = {$_POST['sellfor']}
							WHERE id = {$_POST['id']}
							LIMIT 1", __FILE__, __LINE__);
		$context['shop_buy_message'] = $txt['shop_trade_success'];
		
	$context['sub_template'] = "message";
	loadTemplate('Shop');
	}
	
} elseif ($_GET['do'] == "trade_stop") {
	$context['linktree'][] = array(
		'url' => "$scripturl?action=shop;do=inv",
		'name' => $txt['shop_yourinv'],
	);
	
	$_GET['id'] = (int) $_GET['id'];
	$result = db_query("SELECT ownerid
						FROM {$db_prefix}shop_inventory
						WHERE id = {$_GET['id']}
						LIMIT 1", __FILE__, __LINE__);

	$row = mysql_fetch_array($result, MYSQL_ASSOC);
	if ($row['ownerid'] !== $ID_MEMBER) { //trying to steal other person's item
		$context['shop_buy_message'] = $txt['shop_use_others_item'];
	} else {
		$result = db_query("UPDATE {$db_prefix}shop_inventory
							SET trading = 0, tradecost = 0
							WHERE id = {$_GET['id']}
							LIMIT 1", __FILE__, __LINE__);
		$context['shop_buy_message'] = $txt['shop_trade_cancelled'];
	}

	$context['sub_template'] = "message";
	loadTemplate('Shop');
}
?>